<xsl:stylesheet version="1.0"
  xmlns:xsl   = "http://www.w3.org/1999/XSL/Transform"
  xmlns:exslt = "http://exslt.org/common"
  xmlns:func  = "http://exslt.org/functions"
  xmlns:range = "urn:xpath1range"
  extension-element-prefixes="func">

  <func:function name="range:to">
    <xsl:param name="a"/>
    <xsl:param name="b"/>

    <func:result select="exslt:node-set(range:TO($a,$b))/*/text()"/>
  </func:function>

  <func:function name="range:TO">
    <xsl:param name="a"/>
    <xsl:param name="b"/>

    <xsl:choose>
      <xsl:when test="$a > $b"/>
      <xsl:when test="$a = $b">
        <func:result>
          <e><xsl:value-of select="$a"/></e>
        </func:result>
      </xsl:when>
      <xsl:otherwise>
        <xsl:variable name="m" select="$a + floor(($b - $a) div 2)"/>
        <func:result>
          <xsl:copy-of select="range:TO($a,$m)"/>
          <xsl:copy-of select="range:TO($m+1,$b)"/>
        </func:result>
      </xsl:otherwise>
    </xsl:choose>
  </func:function>

</xsl:stylesheet>

